
let current = GetCurrentScriptDirectory;
let spbg1 = current~"cdbg1.png";
let spbg2 = current~"cdbg2.png";

@Initialize{
	SpellBG;
}
@MainLoop{
	yield;
}


task SpellBG{
	let fade = 0;
	let move = 0;
	let shift = [0, 120, 240];
	let color = [0, 0, 0];
	
	let cdbg1a = CreateBackgroundImageA1(spbg1, 1, 0.25, 1);
	ObjSprite2D_SetSourceRect(cdbg1a, 0, 0, 384, 448);
	ObjSprite2D_SetDestRect(cdbg1a, -32, -32, 416, 480);
	
	let cdbg2a = CreateBackgroundImageA1(spbg2, 1, 0.25, 1);
	ObjSprite2D_SetSourceRect(cdbg2a, 0, 0, 384, 448);
	ObjSprite2D_SetDestRect(cdbg2a, -32, -32, 416, 480);
	ObjRender_SetBlendType(cdbg2a, BLEND_ADD_ARGB);
	
	yield;
	while(!IsCloseScript(GetScriptArgument("PluralID"))){
		let a = GetEnemyBossSceneObjectID;
		if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){
			fade = min(fade+12.75, 255);
		}else{fade=0;}
		
		move++;
		if(move>=448){move = 0;}
		ObjSprite2D_SetSourceRect(cdbg2a, 0, 0+move, 384, 448+move);
		
		ascent(i in 0..3){
			shift[i] = shift[i]+2;
			color[i] = sin(shift[i])*128+127;
		}
		
		ObjRender_SetAlpha(cdbg1a, fade);
		
		ObjRender_SetAlpha(cdbg2a, fade/1.25);
		ObjRender_SetColor(cdbg2a, color[0], color[1], color[2]);
		
		yield;
	}
	
	Obj_Delete(cdbg1a);
	Obj_Delete(cdbg2a);
	CloseScript(GetOwnScriptID);
}

function CreateBackgroundImageA1(image, rect, pri, scale){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestCenter(BG2PropObj);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}
function CreateBackgroundImageB1(image, rect, pri, scale, left, top, right, bottom){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestRect(BG2PropObj, left, top, right, bottom);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}



